# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free
%define namedversion 1.0-beta

Summary:        Java code generation framework
Name:           dynaop
Version:        1.0
Release:        0.beta.3%{?dist}
Epoch:          0
License:        Apache Software License, LGPL
URL:            https://dynaop.dev.java.net/
Group:          Development/Libraries/Java
Source0:        https://dynaop.dev.java.net/files/documents/1189/2965/dynaop-1.0-beta-src.zip
Source1:        http://repo2.maven.org/maven2/dynaop/dynaop/1.0-beta/dynaop-1.0-beta.pom
Patch0:         dynaop-1.0-beta-PatchedObjectInputStream.patch
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-junit
BuildRequires:  asm >= 0:1.5.3
BuildRequires:  bsh2
BuildRequires:  cglib1
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-oro
BuildRequires:  jetty5
BuildRequires:  junit
BuildRequires:  saxon
BuildRequires:  servlet_2_4_api
Requires:  java >= 0:1.5.0
Requires:  jakarta-oro
Requires:  cglib1
Requires:  bsh2
Requires:  asm >= 0:1.5.3
%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
Requires(post):   jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
dynaop, a proxy-based Aspect-Oriented Programming (AOP) 
framework, enhances Object-Oriented (OO) design in the 
following areas:
* code reuse
* decomposition
* dependency reduction

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -c -q -n %{name}
for j in $(find . -name "*.jar"); do
      mv $j $j.no
done

%patch0

%build
pushd lib
ln -sf $(build-classpath bsh2/bsh-classpath) .
ln -sf $(build-classpath bsh2/bsh-commands) .
ln -sf $(build-classpath bsh2/bsh-core) .
ln -sf $(build-classpath bsh2/bsh-reflect) .
ln -sf $(build-classpath bsh2/bsh-util) .
ln -sf $(build-classpath oro) .
ln -sf $(build-classpath cglib1) .
ln -sf $(build-classpath asm/asm) .
pushd build
ln -sf $(build-classpath saxon) .
ln -sf $(build-classpath servlet_2_4_api) .
ln -sf $(build-classpath jetty5/jetty5) .
ln -sf $(build-classpath junit) .
ln -sf $(build-classpath commons-logging) .
popd
popd
ant dist test

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/dist/%{name}-%{version}-beta.jar \
      $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
%add_to_maven_depmap %{name} %{name} %{namedversion} JPP %{name}

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/dist/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr build/dist/manual/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p COPYING $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/COPYING
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Fri Apr 03 2009 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.beta.3.jpp5
- First JPP-5 release
- Patch to Java >= 5

* Mon May 14 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.beta.2jpp
- Make Vendor, Distribution based on macro
- Fix aot build
- Switch to BR servletapi5
- Make all bsh2 jars available in libdir

* Fri Sep 22 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.beta.1jpp
- First JPP-1.7 build
- Add post/postun Requires for javadoc
- Add gcj_support option

